<template>
  <div
    class="container-xxl"
  >
    <div class="row mt-10">
      <div class="flex-column col-12 col-xxl-6 col-xl-6 col-lg-6 mb-5">
        <div class="card shadow-sm">
          <div
            v-if="response.mostrar === 'LOADING'"
            class="d-flex justify-content-center py-20"
          >
            <div
              class="spinner-border text-primary"
              style="width: 4rem; height: 4rem; border-width: 0.35rem"
              role="status"
            >
              <span class="visually-hidden">Cargando...</span>
            </div>
          </div>

          <div
            v-else
            class="card-body"
          >
            <div class="d-flex flex-column">
              <div class="align-self-center mb-2">
                <label
                  class="text-gray-900 fs-3 fw-bolder"
                  v-text="subasta.titulo"
                />
              </div>
            </div>
            <div class="mt-10 mb-5">
              <table class="table table-flush fw-bold fs-5 gy-1">
                <tbody>
                  <tr>
                    <td class="text-gray-900 fw-bolder min-w-125px w-125px">
                      Cantidad:
                    </td>
                    <td class="text-gray-800">
                      {{ subasta.cantidadAnimal + ' Cabezas' }}
                    </td>
                  </tr>
                  <tr>
                    <td class="text-gray-900 fw-bolder min-w-125px w-125px">
                      Peso promedio:
                    </td>
                    <td class="text-gray-800">
                      {{ subasta.pesoPromedio + ' kg' }}
                    </td>
                  </tr>
                  <tr>
                    <td class="text-gray-900 fw-bolder min-w-150px w-150px">
                      Precio referencial:
                    </td>
                    <td class="text-gray-800">
                      {{ subasta.precioReferencial + ' ' + subasta.tipoMoneda }}
                    </td>
                  </tr>
                  <tr>
                    <td class="text-gray-900 fw-bolder min-w-125px w-125px">
                      Teléfono:
                    </td>
                    <td class="text-gray-800">
                      {{ subasta.telefonoCentro }}
                    </td>
                  </tr>
                  <tr>
                    <td class="text-gray-900 fw-bolder min-w-125px w-125px">
                      Fecha de remate:
                    </td>
                    <td class="text-gray-800">
                      {{ subasta.fechaRemate }}
                    </td>
                  </tr>
                  <tr>
                    <td class="text-gray-900 fw-bolder min-w-125px w-125px">
                      Hora de remate:
                    </td>
                    <td class="text-gray-800">
                      {{ subasta.horaRemate }}
                    </td>
                  </tr>
                  <tr>
                    <td class="text-gray-900 fw-bolder min-w-125px w-125px">
                      Registrado:
                    </td>
                    <td class="text-gray-800">
                      {{ subasta.fechaHoraRegistrado }}
                    </td>
                  </tr>
                </tbody>
              </table>
            </div>
            <label class="fs-5 fw-bolder text-dark">Geolocalización y Dirección</label>
            <div class="mb-5">
              <GoogleMap
                api-key="AIzaSyA2XeZf5gGUwUTKl9y-hq2GsMdTlCJCgds"
                style="width: 100%; height: 300px"
                :center="{lat: subasta.latitud, lng: subasta.longitud}"
                :zoom="10"
              >
                <Marker :options="{ position: {lat: subasta.latitud, lng: subasta.longitud}, draggable: false, clickable: false }" />
              </GoogleMap>
            </div>
            <div class="mb-5">
              <label class="fs-5 form-label fw-bolder text-dark">Descripción:</label>
              <div v-html="subasta.descripcion" />
            </div>
          </div>
        </div>
      </div>

      <div class="col-12 col-lg-6 d-flex flex-column">
        <div class="card card-flush shadow-sm">
          <div class="card-header d-flex flex-column flex-md-row">
            <h3 class="card-title fw-bolder text-dark">
              Galería
            </h3>
            <div class="card-toolbar justify-content-end">
              <button
                class="btn btn-success shadow-sm"
                data-bs-toggle="modal"
                data-bs-target="#modal_galeria_crear"
              >
                <i class="bi bi-plus-lg fs-4 me-2" />Subir Foto
              </button>
              <button
                class="btn btn-primary ms-5"
                @click="onGaleriaListar()"
              >
                <i class="bi bi-arrow-clockwise fs-4 me-2" />Actualizar
              </button>
            </div>
          </div>
        </div>

        <div
          v-if="response.listar === 'LOADING'"
          class="d-flex justify-content-center py-20"
        >
          <div
            class="spinner-border text-primary"
            style="width: 4rem; height: 4rem; border-width: 0.35rem"
            role="status"
          >
            <span class="visually-hidden">Cargando...</span>
          </div>
        </div>

        <div
          v-else
          class="row mt-5"
        >
          <div
            v-for="(img, index) in imagenes"
            :key="index"
            class="col-12 col-md-6 pic"
            style="cursor:pointer;"
          >
            <div class="card-xl-stretch shadow-sm">
              <div class="d-block overlay mb-4">
                <div
                  class="overlay-wrapper bgi-no-repeat bgi-position-center bgi-size-cover rounded min-h-175px"
                  :style="'background-image:url(' + img.url + ')'"
                />
                <div class="overlay-layer bg-dark bg-opacity-50 align-items-end justify-content-center">
                  <div class="d-flex flex-grow-1 flex-center  py-5">
                    <button
                      class="btn btn-primary btn-shadow"
                      @click="lightboxShowImg(index)"
                    >
                      Abrir
                    </button>
                    <button
                      class="btn btn-danger btn-shadow ms-2"
                      data-bs-toggle="modal"
                      data-bs-target="#modal_galeria_eliminar"
                      @click="onGaleriaEliminar(img)"
                    >
                      Eliminar
                    </button>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <vue-easy-lightbox
          :visible="lightbox.visible"
          :imgs="lightbox.imgs"
          :index="lightbox.index"
          @hide="lightboxHandleHide()"
        />
      </div>
    </div>
    <modal-eliminar
      :galeria="sGaleria"
      @on-galeria-listar="onGaleriaListar"
    />
    <modal-crear @on-galeria-listar="onGaleriaListar" />
  </div>
</template>
<script>
import ModalCrear from '@/components/panel/subasta/galeria/ModalGaleriaCrear.vue';
import ModalEliminar from '@/components/panel/subasta/galeria/ModalGaleriaEliminar.vue';

import VueEasyLightbox from 'vue-easy-lightbox'
import Servicio from "@/core/servicio/Servicio";
import Ruta from "@/core/servicio/Ruta";
import Toast from "@/core/util/Toast";
import Convertidor from "@/core/util/Convertidor";
import Alerta from "@/core/util/Alerta";
import { GoogleMap, Marker  } from "vue3-google-map";

export default {
  name: 'SubastaMostrar',
  components: {
    VueEasyLightbox, GoogleMap, Marker, ModalCrear, ModalEliminar
  },
  data() {
    return {
      sGaleria: {},
      subasta: {
        id: '',
        titulo: '',
        cantidadAnimal: '',
        pesoPromedio: '',
        precioReferencial: '',
        tipoMoneda: '',
        telefonoCentro: '',
        descripcion: '',
        fechaRemate: '',
        horaRemate: '',
        latitud: '',
        longitud: '',
        fechaHoraRegistrado: '',
      },
      imagenes: [],
      lightbox: {
        visible: false,
        index: 0,
        imgs: []
      },
      response: {
        mostrar: 'LOADING',
        listar: 'LOADING'
      }
    }
  },
  mounted() {
    this.onSubastaMostrar();
    this.onGaleriaListar();
  },
  methods: {
    onSubastaMostrar() {
      this.response.mostrar = 'LOADING';
      Servicio.get(Ruta.rutaPanelSubastaMostrar(this.$route.params.id)).then( (data) => {
        this.subasta = data.data;
        this.response.mostrar = data.estado;
      }).catch( (error) => {
        this.response.mostrar = 'ERROR';
        Toast.mostrarError(error);
      });
    },

    onGaleriaListar() {
      this.response.listar = 'LOADING';
      Servicio.get(Ruta.rutaPanelSubastasGaleriaListar(this.$route.params.id)).then( (data) => {
        this.imagenes = data.data;
        this.lightbox.imgs = Convertidor.arrayObjectToArray(this.imagenes, 'url');
        this.response.listar = data.estado;
      }).catch( (error) => {
        this.response.listar = 'ERROR';
        Alerta.alertaError(error);
      });
    },

    onGaleriaEliminar(galeria) {
      this.sGaleria = galeria;
    },

    lightboxShowImg(index) {
      this.lightbox.index = index
      this.lightbox.visible = true
    },

    lightboxHandleHide() {
      this.lightbox.visible = false
    }
  }
}
</script>